"use strict";
/* eslint-disable @typescript-eslint/no-explicit-any */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withFieldLabel = exports.getDisplayName = void 0;
var react_native_commons_collection_1 = require("@react-pakistan/react-native-commons-collection");
var react_1 = __importDefault(require("react"));
var styled_1 = require("./styled");
var themes_1 = require("../../themes");
var getDisplayName = function (Component) { return Component.displayName || 'Component'; };
exports.getDisplayName = getDisplayName;
var withFieldLabel = function (WrappedComponent) {
    function Wrapper(_a) {
        var hasError = _a.hasError, helperText = _a.helperText, helperTextColor = _a.helperTextColor, label = _a.label, theme = _a.theme, rest = __rest(_a, ["hasError", "helperText", "helperTextColor", "label", "theme"]);
        return (react_1.default.createElement(styled_1.StyledWrapper, null,
            label && (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(react_native_commons_collection_1.Text, __assign({}, ((theme === null || theme === void 0 ? void 0 : theme.typography.label) || themes_1.generalTheme.typography.label)), label),
                react_1.default.createElement(react_native_commons_collection_1.Spacer, { marginVertical: (theme === null || theme === void 0 ? void 0 : theme.spacing.xsmall) || themes_1.generalTheme.spacing.xsmall }))),
            react_1.default.createElement(WrappedComponent, __assign({ hasError: hasError }, rest)),
            helperText && (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(react_native_commons_collection_1.Spacer, { marginVertical: (theme === null || theme === void 0 ? void 0 : theme.spacing.xsmall) || themes_1.generalTheme.spacing.xsmall }),
                react_1.default.createElement(react_native_commons_collection_1.Text, __assign({}, ((theme === null || theme === void 0 ? void 0 : theme.typography.text) || themes_1.generalTheme.typography.text), { color: hasError ? helperTextColor : '' }), helperText)))));
    }
    Wrapper.displayName = "withFieldLabel(".concat((0, exports.getDisplayName)(WrappedComponent), ")");
    return Wrapper;
};
exports.withFieldLabel = withFieldLabel;
