"use strict";
/* eslint-disable @typescript-eslint/no-explicit-any */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Shimmer = void 0;
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var linear_gradient_1 = require("../linear-gradient");
var styled_1 = require("./styled");
var type_1 = require("./type");
var AnimatedLinearGradient = react_native_1.Animated.createAnimatedComponent(linear_gradient_1.LinearGradient);
exports.Shimmer = (0, react_1.memo)(function (_a) {
    var autoRun = _a.autoRun, children = _a.children, colors = _a.colors, height = _a.height, isLoading = _a.isLoading, type = _a.type, width = _a.width;
    var shimmerStartPosition = (0, react_1.useState)(new react_native_1.Animated.Value(-1))[0];
    var shimmerLocation = shimmerStartPosition.interpolate({
        inputRange: type_1.SHIMMER_CONSTANTS_MAP[type_1.SHIMMER_CONSTANTS.SHIMMER_INPUT_RANGE],
        outputRange: [
            type_1.SHIMMER_CONSTANTS_MAP[type_1.SHIMMER_CONSTANTS.SHIMMER_START],
            type_1.SHIMMER_CONSTANTS_MAP[type_1.SHIMMER_CONSTANTS.SHIMMER_END],
        ],
    });
    var loopAnimated = (0, react_1.useCallback)(function (shimmerAnimation) {
        shimmerStartPosition.setValue(-1);
        shimmerAnimation.start(function (_a) {
            var finished = _a.finished;
            if (isLoading && finished) {
                loopAnimated(shimmerAnimation);
                return;
            }
            shimmerAnimation.stop();
        });
    }, [isLoading, shimmerStartPosition]);
    (0, react_1.useEffect)(function () {
        if (autoRun && isLoading) {
            var shimmerAnimation = react_native_1.Animated.timing(shimmerStartPosition, {
                toValue: 0,
                duration: type_1.SHIMMER_CONSTANTS_MAP[type_1.SHIMMER_CONSTANTS.SHIMMERS_TIME_BETWEEN],
                useNativeDriver: false,
            });
            loopAnimated(shimmerAnimation);
        }
    }, [autoRun, isLoading, loopAnimated, shimmerStartPosition]);
    if (!isLoading && children) {
        return children;
    }
    return (react_1.default.createElement(styled_1.StyledShimmer, { height: height, width: width, type: type },
        react_1.default.createElement(AnimatedLinearGradient, { colors: colors, shimmerLocation: shimmerLocation, shimmerSize: type_1.SHIMMER_CONSTANTS_MAP[type_1.SHIMMER_CONSTANTS.SHIMMER_SIZE] })));
});
