import { ReactElement, ReactText } from 'react';
export interface ILineShimmerProps {
    /**
     * Height of line Shimmer
     */
    height: ReactText;
    /**
     * Width of line Shimmer
     */
    width: ReactText;
}
export interface IOvalShimmerProps {
    /**
     *
     */
    size: number;
}
export declare const SHIMMER_CONSTANTS_MAP: {
    inputRange: number[];
    timeBetween: number;
    size: number;
    start: number;
    end: number;
};
export declare enum SHIMMER_TYPES {
    LINE = "line",
    OVAL = "oval"
}
export declare enum SHIMMER_CONSTANTS {
    SHIMMER_INPUT_RANGE = "inputRange",
    SHIMMERS_TIME_BETWEEN = "timeBetween",
    SHIMMER_SIZE = "size",
    SHIMMER_START = "start",
    SHIMMER_END = "end"
}
export interface IShimmerProps {
    /**
     * Whether or not to show shimmering effect
     */
    autoRun: boolean;
    /**
     * Children rendered within shimmer
     */
    children?: ReactElement;
    /**
     * Color of the shimmer
     */
    colors: Array<ReactText>;
    /**
     * Height of shimmer
     */
    height?: ReactText;
    /**
     * Defines loading state of shimmer
     */
    isLoading: boolean;
    /**
     * Defines the different types of shimmer
     */
    type: SHIMMER_TYPES;
    /**
     * Width of shimmer
     */
    width?: ReactText;
}
