"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextInputIconWrapper = exports.StyledTextInput = exports.TextInputWrapper = exports.TEXT_INPUT_COLORS_MAP = exports.TEXT_INPUT_BORDER_WIDTH_MAP = void 0;
var react_native_commons_collection_1 = require("@react-pakistan/react-native-commons-collection");
var react_native_1 = require("react-native");
var styled_components_1 = require("styled-components");
var native_1 = __importDefault(require("styled-components/native"));
var themes_1 = require("../themes");
var type_1 = require("./type");
var paddingDifference = react_native_1.Platform.OS === 'ios' ? -5 : 0;
exports.TEXT_INPUT_BORDER_WIDTH_MAP = {
    default: '1px',
    error: '2px',
    focus: '2px',
};
exports.TEXT_INPUT_COLORS_MAP = {
    default: themes_1.generalTheme.colors.lightGrey,
    error: themes_1.generalTheme.colors.cherryRed,
    focus: themes_1.generalTheme.colors.skyBlue,
};
exports.TextInputWrapper = native_1.default.View(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n  justify-content: space-between;\n  position: relative;\n  width: ", ";\n"], ["\n  display: flex;\n  justify-content: space-between;\n  position: relative;\n  width: ", ";\n"])), function (_a) {
    var width = _a.width;
    return width || '100%';
});
exports.StyledTextInput = (0, native_1.default)(react_native_commons_collection_1.TextInput)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  color: ", ";\n  font-family: ", ";\n  font-size: ", "px;\n  letter-spacing: ", "px;\n  line-height: ", "px;\n  text-align: ", ";\n  text-transform: ", ";\n\n  background-color: ", ";\n  border-radius: ", "px;\n\n  border: ", ";\n  color: ", ";\n  line-height: ", "px;\n  margin-bottom: ", "px;\n  margin-top: ", "px;\n  opacity: ", ";\n\n  padding-bottom: ", "px;\n  padding-left: ", "px;\n  padding-right: ", "px;\n  padding-top: ", "px;\n\n  ", ";\n  textAlignVertical: ", ";\n\n  width: 100%;\n"], ["\n  color: ", ";\n  font-family: ", ";\n  font-size: ", "px;\n  letter-spacing: ", "px;\n  line-height: ", "px;\n  text-align: ", ";\n  text-transform: ", ";\n\n  background-color: ", ";\n  border-radius: ", "px;\n\n  border: ", ";\n  color: ", ";\n  line-height: ", "px;\n  margin-bottom: ", "px;\n  margin-top: ", "px;\n  opacity: ", ";\n\n  padding-bottom: ", "px;\n  padding-left: ", "px;\n  padding-right: ", "px;\n  padding-top: ", "px;\n\n  ", ";\n  textAlignVertical: ", ";\n\n  width: 100%;\n"])), function (_a) {
    var theme = _a.theme;
    return theme.colors.black;
}, function (_a) {
    var theme = _a.theme;
    return theme.typography.p5.fontFamily;
}, function (_a) {
    var theme = _a.theme;
    return theme.typography.p5.fontSize;
}, function (_a) {
    var theme = _a.theme;
    return theme.typography.p5.letterSpacing;
}, function (_a) {
    var theme = _a.theme;
    return theme.typography.p5.lineHeight;
}, function (_a) {
    var theme = _a.theme;
    return theme.typography.p5.textAlign;
}, function (_a) {
    var theme = _a.theme;
    return theme.typography.p5.textTransform;
}, function (_a) {
    var theme = _a.theme;
    return theme.colors.lightGrey;
}, function (_a) {
    var theme = _a.theme;
    return theme.radius.default;
}, function (_a) {
    var hasError = _a.hasError, type = _a.type, theme = _a.theme;
    return (hasError
        ? "2px solid ".concat(theme.colors.cherryRed)
        : "".concat(exports.TEXT_INPUT_BORDER_WIDTH_MAP[type], " solid ").concat(exports.TEXT_INPUT_COLORS_MAP[type]));
}, function (_a) {
    var theme = _a.theme;
    return theme.colors.black;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacing.default + 4;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacing.small;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacing.small;
}, function (_a) {
    var disabled = _a.disabled;
    return (disabled ? 0.6 : 1);
}, function (_a) {
    var multiline = _a.multiline, theme = _a.theme;
    return (multiline
        ? theme.spacing.small
        : theme.spacing.default + paddingDifference);
}, function (_a) {
    var iconFront = _a.iconFront, theme = _a.theme;
    return (iconFront
        ? theme.spacing.huge
        : theme.spacing.default + paddingDifference);
}, function (_a) {
    var iconBack = _a.iconBack, theme = _a.theme;
    return (iconBack
        ? theme.spacing.huge
        : theme.spacing.default + paddingDifference);
}, function (_a) {
    var theme = _a.theme;
    return theme.spacing.default + paddingDifference;
}, function (_a) {
    var multiline = _a.multiline, theme = _a.theme;
    return (!multiline
        && (0, styled_components_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["height: ", "px"], ["height: ", "px"])), theme.spacing.huge + 2));
}, function (_a) {
    var multiline = _a.multiline;
    return (multiline ? 'top' : 'center');
});
exports.TextInputIconWrapper = (0, native_1.default)(react_native_commons_collection_1.TouchableOpacity)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  bottom: ", "px;\n  ", ";\n  position: absolute;\n  ", ";\n  width: ", "px;\n  height: ", "px;\n"], ["\n  bottom: ", "px;\n  ", ";\n  position: absolute;\n  ", ";\n  width: ", "px;\n  height: ", "px;\n"])), function (_a) {
    var theme = _a.theme;
    return theme.spacing.large - 2;
}, function (_a) {
    var iconType = _a.iconType, theme = _a.theme;
    return (iconType
        === type_1.TEXT_INPUT_ICON_TYPES.FRONT && (0, styled_components_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["left: ", "px"], ["left: ", "px"])), theme.spacing.default));
}, function (_a) {
    var iconType = _a.iconType, theme = _a.theme;
    return (iconType
        === type_1.TEXT_INPUT_ICON_TYPES.BACK && (0, styled_components_1.css)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["right: ", "px"], ["right: ", "px"])), theme.spacing.default));
}, function (_a) {
    var theme = _a.theme;
    return theme.spacing.default + 4;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacing.default + 4;
});
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;
