"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextInputWithFieldLabel = exports.TextInput = void 0;
var react_1 = __importDefault(require("react"));
var styled_components_1 = require("styled-components");
var field_label_1 = require("../hoc/field-label");
var styled_1 = require("./styled");
var text_input_icon_1 = require("./text-input-icon");
var type_1 = require("./type");
exports.TextInput = (0, styled_components_1.withTheme)(function (_a) {
    var backIconPressHandler = _a.backIconPressHandler, frontIconPressHandler = _a.frontIconPressHandler, hasError = _a.hasError, iconBack = _a.iconBack, iconFront = _a.iconFront, theme = _a.theme, width = _a.width, rest = __rest(_a, ["backIconPressHandler", "frontIconPressHandler", "hasError", "iconBack", "iconFront", "theme", "width"]);
    var iconBackComponent;
    var iconFrontComponent;
    if (iconBack) {
        iconBackComponent = (react_1.default.createElement(text_input_icon_1.TextInputIcon, { color: hasError ? theme.colors.cherryRed : theme.colors.black, iconName: iconBack, iconType: type_1.TEXT_INPUT_ICON_TYPES.BACK, onPress: backIconPressHandler }));
    }
    if (iconFront) {
        iconFrontComponent = (react_1.default.createElement(text_input_icon_1.TextInputIcon, { color: hasError ? theme.colors.cherryRed : theme.colors.black, iconName: iconFront, iconType: type_1.TEXT_INPUT_ICON_TYPES.FRONT, onPress: frontIconPressHandler }));
    }
    return (react_1.default.createElement(styled_1.TextInputWrapper, { width: width },
        react_1.default.createElement(styled_1.StyledTextInput, __assign({ hasError: hasError, iconBack: iconBack, iconFront: iconFront }, rest)),
        iconBackComponent,
        iconFrontComponent));
});
exports.TextInputWithFieldLabel = (0, field_label_1.withFieldLabel)(exports.TextInput);
