"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WatsonCartItem = void 0;
var react_native_commons_collection_1 = require("@react-pakistan/react-native-commons-collection");
var icon_1 = require("@react-pakistan/react-native-icon-collection/icon");
var react_1 = __importStar(require("react"));
var native_1 = require("styled-components/native");
var watson_brand_name_1 = require("../watson-brand-name");
var watson_button_1 = require("../watson-button");
var watson_product_image_1 = require("../watson-product-image");
var watson_product_title_1 = require("../watson-product-title");
var watson_price_1 = require("../watson-price");
var watson_quantity_1 = require("../watson-quantity");
var styled_1 = require("./styled");
exports.WatsonCartItem = (0, react_1.memo)((0, native_1.withTheme)(function (_a) {
    var brand = _a.brand, buttonText = _a.buttonText, onButtonPressHandler = _a.onButtonPressHandler, onDeletePressHandler = _a.onDeletePressHandler, onNegativePressHandler = _a.onNegativePressHandler, onPositivePressHandler = _a.onPositivePressHandler, originalPrice = _a.originalPrice, price = _a.price, productImageUrl = _a.productImageUrl, productName = _a.productName, quantity = _a.quantity, theme = _a.theme;
    return (react_1.default.createElement(styled_1.WatsonCartItemWrapper, null,
        react_1.default.createElement(styled_1.ImageWrapper, null,
            react_1.default.createElement(watson_product_image_1.WatsonProductImage, { productImageUrl: productImageUrl })),
        react_1.default.createElement(react_native_commons_collection_1.Spacer, { marginHorizontal: theme.spacing.xsmall }),
        react_1.default.createElement(styled_1.MidWrapper, null,
            react_1.default.createElement(watson_product_title_1.WatsonProductTitle, { productName: productName }),
            react_1.default.createElement(watson_brand_name_1.WatsonBrandName, { brand: brand }),
            react_1.default.createElement(react_native_commons_collection_1.Spacer, { marginVertical: theme.spacing.xsmall }),
            react_1.default.createElement(watson_button_1.WatsonButton, { buttonText: buttonText, onPressHandler: onButtonPressHandler, type: watson_button_1.WATSON_BUTTON_VARIANTS.PRIMARY }),
            react_1.default.createElement(react_native_commons_collection_1.Spacer, { marginVertical: theme.spacing.xsmall }),
            react_1.default.createElement(watson_quantity_1.WatsonQuantity, { onNegativePressHandler: onNegativePressHandler, onPositivePressHandler: onPositivePressHandler, quantity: quantity })),
        react_1.default.createElement(react_native_commons_collection_1.Spacer, { marginHorizontal: theme.spacing.xsmall }),
        react_1.default.createElement(styled_1.PriceWrapper, null,
            react_1.default.createElement(styled_1.TopWrapper, null,
                react_1.default.createElement(watson_price_1.WatsonPrice, { price: price }),
                react_1.default.createElement(react_native_commons_collection_1.Spacer, { marginVertical: theme.spacing.xsmall }),
                react_1.default.createElement(watson_price_1.WatsonPrice, { originalPrice: originalPrice })),
            react_1.default.createElement(styled_1.IconWrapper, { onPress: onDeletePressHandler },
                react_1.default.createElement(icon_1.Icon, { icon: 'MiscGrey76', fill: theme.colors.watsonPink })))));
}));
